/// @cond EO_CXX_EO_IMPL

inline void elm::table::clear(bool clear_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_clear(::efl::eolian::to_c(clear_)));
}

inline ::evas::object elm::table::child_get(int col_, int row_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_table_child_get(col_, row_));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::table::pack_set(::evas::object subobj_, int column_, int row_, int colspan_, int rowspan_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_pack_set(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
}

inline void elm::table::pack_get(::evas::object subobj_, int* column_, int* row_, int* colspan_, int* rowspan_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_pack_get(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
}

inline void elm::table::unpack(::evas::object subobj_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_unpack(::efl::eolian::to_c(subobj_)));
}

inline void elm::table::pack(::evas::object subobj_, int column_, int row_, int colspan_, int rowspan_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_pack(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
}

inline bool elm::table::homogeneous_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_table_homogeneous_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::table::homogeneous_set(bool homogeneous_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_homogeneous_set(::efl::eolian::to_c(homogeneous_)));
}

inline void elm::table::padding_get(Evas_Coord* horizontal_, Evas_Coord* vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_padding_get(horizontal_, vertical_));
}

inline void elm::table::padding_set(Evas_Coord horizontal_, Evas_Coord vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_padding_set(horizontal_, vertical_));
}

inline void elm::table::align_get(double* horizontal_, double* vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_align_get(horizontal_, vertical_));
}

inline void elm::table::align_set(double horizontal_, double vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_align_set(horizontal_, vertical_));
}

inline void eo_cxx::elm::table::clear(bool clear_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_clear(::efl::eolian::to_c(clear_)));
}

inline ::evas::object eo_cxx::elm::table::child_get(int col_, int row_) const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_table_child_get(col_, row_));
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::table::pack_set(::evas::object subobj_, int column_, int row_, int colspan_, int rowspan_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_pack_set(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
}

inline void eo_cxx::elm::table::pack_get(::evas::object subobj_, int* column_, int* row_, int* colspan_, int* rowspan_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_pack_get(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
}

inline void eo_cxx::elm::table::unpack(::evas::object subobj_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_unpack(::efl::eolian::to_c(subobj_)));
}

inline void eo_cxx::elm::table::pack(::evas::object subobj_, int column_, int row_, int colspan_, int rowspan_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_pack(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
}

inline bool eo_cxx::elm::table::homogeneous_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_table_homogeneous_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::table::homogeneous_set(bool homogeneous_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_homogeneous_set(::efl::eolian::to_c(homogeneous_)));
}

inline void eo_cxx::elm::table::padding_get(Evas_Coord* horizontal_, Evas_Coord* vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_padding_get(horizontal_, vertical_));
}

inline void eo_cxx::elm::table::padding_set(Evas_Coord horizontal_, Evas_Coord vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_padding_set(horizontal_, vertical_));
}

inline void eo_cxx::elm::table::align_get(double* horizontal_, double* vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_align_get(horizontal_, vertical_));
}

inline void eo_cxx::elm::table::align_set(double horizontal_, double vertical_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_table_align_set(horizontal_, vertical_));
}

inline ::eo_cxx::elm::table::operator ::elm::table() const
{
   return *static_cast<::elm::table const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::table::operator ::elm::table&()
{
   return *static_cast<::elm::table*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::table::operator ::elm::table const&() const
{
   return *static_cast<::elm::table const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_table_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool clear_)
{
   try
      {
         static_cast<T*>(self->this_)->clear(::efl::eolian::to_cxx<bool>(clear_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::evas::object elm_table_child_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int col_, int row_)
{
   try
      {
         return static_cast<T*>(self->this_)->child_get(col_, row_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_table_pack_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * subobj_, int column_, int row_, int colspan_, int rowspan_)
{
   try
      {
         static_cast<T*>(self->this_)->pack_set(::efl::eolian::to_cxx<::evas::object>(subobj_, std::tuple<std::false_type>()), column_, row_, colspan_, rowspan_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_table_pack_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * subobj_, int* column_, int* row_, int* colspan_, int* rowspan_)
{
   try
      {
         static_cast<T*>(self->this_)->pack_get(::efl::eolian::to_cxx<::evas::object>(subobj_, std::tuple<std::false_type>()), column_, row_, colspan_, rowspan_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_table_unpack_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * subobj_)
{
   try
      {
         static_cast<T*>(self->this_)->unpack(::efl::eolian::to_cxx<::evas::object>(subobj_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_table_pack_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * subobj_, int column_, int row_, int colspan_, int rowspan_)
{
   try
      {
         static_cast<T*>(self->this_)->pack(::efl::eolian::to_cxx<::evas::object>(subobj_, std::tuple<std::false_type>()), column_, row_, colspan_, rowspan_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_table_homogeneous_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->homogeneous_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_table_homogeneous_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool homogeneous_)
{
   try
      {
         static_cast<T*>(self->this_)->homogeneous_set(::efl::eolian::to_cxx<bool>(homogeneous_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_table_padding_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* horizontal_, Evas_Coord* vertical_)
{
   try
      {
         static_cast<T*>(self->this_)->padding_get(horizontal_, vertical_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_table_padding_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord horizontal_, Evas_Coord vertical_)
{
   try
      {
         static_cast<T*>(self->this_)->padding_set(horizontal_, vertical_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_table_align_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* horizontal_, double* vertical_)
{
   try
      {
         static_cast<T*>(self->this_)->align_get(horizontal_, vertical_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_table_align_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double horizontal_, double vertical_)
{
   try
      {
         static_cast<T*>(self->this_)->align_set(horizontal_, vertical_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::table >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget >::template type<T>
   {
      virtual void clear(bool clear_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_clear(::efl::eolian::to_c(clear_)));
      }

      virtual ::evas::object child_get(int col_, int row_)
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_table_child_get(col_, row_));
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void pack_set(::evas::object subobj_, int column_, int row_, int colspan_, int rowspan_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_pack_set(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
      }

      virtual void pack_get(::evas::object subobj_, int* column_, int* row_, int* colspan_, int* rowspan_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_pack_get(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
      }

      virtual void unpack(::evas::object subobj_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_unpack(::efl::eolian::to_c(subobj_)));
      }

      virtual void pack(::evas::object subobj_, int column_, int row_, int colspan_, int rowspan_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_pack(::efl::eolian::to_c(subobj_), column_, row_, colspan_, rowspan_));
      }

      virtual bool homogeneous_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_table_homogeneous_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void homogeneous_set(bool homogeneous_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_homogeneous_set(::efl::eolian::to_c(homogeneous_)));
      }

      virtual void padding_get(Evas_Coord* horizontal_, Evas_Coord* vertical_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_padding_get(horizontal_, vertical_));
      }

      virtual void padding_set(Evas_Coord horizontal_, Evas_Coord vertical_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_padding_set(horizontal_, vertical_));
      }

      virtual void align_get(double* horizontal_, double* vertical_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_align_get(horizontal_, vertical_));
      }

      virtual void align_set(double horizontal_, double vertical_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_table_align_set(horizontal_, vertical_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::table >
{
   static constexpr int value = 
#if defined(TABLE_PROTECTED) && defined(TABLE_BETA)
      12
#elif defined(TABLE_PROTECTED)
      12
#elif defined(TABLE_BETA)
      12
#else
      12
#endif
      + operation_description_class_size<::elm::widget >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::table>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_table_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_child_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_child_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_pack_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_pack_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_pack_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_pack_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_unpack_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_unpack);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_pack_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_pack);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_homogeneous_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_homogeneous_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_homogeneous_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_homogeneous_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_padding_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_padding_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_padding_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_padding_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_align_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_align_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_table_align_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_table_align_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget>(), &ops[operation_description_class_size< ::elm::table >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::table>)
{
   return (ELM_TABLE_CLASS);
}

} } }

/// @endcond

